﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;
using Telerik.Web.UI;

public partial class Default : System.Web.UI.Page
{
	protected void Page_Load(object sender, EventArgs e)
	{
		if (!Page.IsPostBack)
		{
			RadHtmlChart1.DataSource = getGroupedData(CreateDataSource());
			RadHtmlChart1.DataBind();
		}
	}

	protected void setHtmlChartSeries(RadHtmlChart HtmlChart, int index) 
	{
		ColumnSeries columnSeries1 = new ColumnSeries();
		columnSeries1.DataFieldY = "VehicleCount" + index;
		columnSeries1.TooltipsAppearance.ClientTemplate = "#=dataItem.anotherField" + index + "#<br />#=dataItem.YearMonth" + index + "#<br />#=dataItem.VehicleCount" + index + "#";
		columnSeries1.LabelsAppearance.DataFormatString = "{0:N0}";
		HtmlChart.PlotArea.Series.Add(columnSeries1);
	}

	protected DataTable getGroupedData(DataTable rowDataTable)
	{
		DataView dv = rowDataTable.DefaultView;

		//Get number of distinct rows by "Nationality" column
		DataTable distinctValues = dv.ToTable(true, "Nationality");
		int numDistinctValues = distinctValues.Rows.Count;

		DataTable oldDT = CreateDataSource();
		DataTable newDT = new DataTable();

		DataTable[] dtarr = new DataTable[numDistinctValues];

		for (int i = 0; i < numDistinctValues; i++)
		{
			//Split current datatable to multiple datatables
			dtarr[i] = oldDT.Select("Nationality='" + distinctValues.Rows[i][0].ToString() + "'").CopyToDataTable();

			//Set g-th index to the columns of each g-th datatable
			for (int g = 0; g < dtarr[i].Columns.Count; g++)
			{
				string columnName = dtarr[i].Columns[g].ColumnName + i;
				dtarr[i].Columns[g].ColumnName = columnName;
				//Add new columns to the new datasource
				newDT.Columns.Add(columnName);
			}
		}

		//Add new rows to the datasource
		for (int i = 0; i < dtarr[0].Rows.Count; i++)
		{
			newDT.Rows.Add();
		}

		//Create a common datasource
		for (int i = 0; i < numDistinctValues; i++)
		{
			DataTable currDT = dtarr[i];

			//Set the RadHtmlChart settings
			setHtmlChartSeries(RadHtmlChart1, i);

			//Loop through the columns of the current datatable
			for (int g = 0; g < currDT.Columns.Count; g++)
			{
				//Loop through the rows of the current datatable
				for (int f = 0; f < currDT.Rows.Count; f++)
				{
					string columnName = currDT.Columns[g].ColumnName;
					newDT.Rows[f][columnName] = currDT.Rows[f][columnName];
				}
			}
		}
		return newDT;
	}

	private DataTable CreateDataSource()
	{
		DataTable dtDataPoints = new DataTable();

		dtDataPoints.Columns.Add(new DataColumn("Nationality"));
		dtDataPoints.Columns.Add(new DataColumn("anotherField"));
		dtDataPoints.Columns.Add(new DataColumn("YearMonth"));
		dtDataPoints.Columns.Add(new DataColumn("VehicleCount"));

		dtDataPoints.Rows.Add(new object[] { "UK", "some text1", "2012 - December", null });
		dtDataPoints.Rows.Add(new object[] { "UK", "some text1", "2013 - January", null });
		dtDataPoints.Rows.Add(new object[] { "UK", "some text2", "2013 - February", null });
		dtDataPoints.Rows.Add(new object[] { "UK", "some text2", "2013 - March", 15 });
		dtDataPoints.Rows.Add(new object[] { "UK", "some text2", "2013 - April", 21 });
		dtDataPoints.Rows.Add(new object[] { "NI", "some text3", "2012 - December", 99 });
		dtDataPoints.Rows.Add(new object[] { "NI", "some text3", "2013 - January", 98 });
		dtDataPoints.Rows.Add(new object[] { "NI", "some text4", "2013 - February", 96 });
		dtDataPoints.Rows.Add(new object[] { "NI", "some text5", "2013 - March", 95 });
		dtDataPoints.Rows.Add(new object[] { "NI", "some text5", "2013 - April", 91 });

		return dtDataPoints;
	}
}